<script lang="ts">
export default {
  data() {
    return {
      count: 0,
      isActive: true,
      author: {
        name: 'John Doe',
        books: [
          'Vue 2 - Advanced Guide',
          'Vue 3 - Basic Guide',
          'Vue 4 - The Mystery'
        ]
      },
      text: '',
      initialCounter: 0
    }
  },
  methods: {
    increase() {
      this.count++;
    },
    toggle() {
      this.isActive = !this.isActive;
    },
    submit() {
      alert(this.text);
    },
    increment() {
      this.$store.commit('increment')
    },
    decrement() {
      this.$store.commit('decrement')
    },
    resetToZero() {
      this.$store.commit('resetToZero');
    }
  },
  computed: {
    publishedBooksMessage(): string {
      return this.author.books.length > 0 ? 'Yes' : 'No';
    }
  },
  watch: {
    text(newText: string, oldText: string) {
      if (newText.includes('?')) {
        this.toggle();
      }
    }
  }
}
</script>

<template>
  <section class="demo">
    <h1>This is an DEMO page</h1>
    <button @click="increase">{{ count }}</button>
    <hr />
    <button @click="toggle">Toggle</button>
    <p v-if="isActive">lorem lorem lorem</p>
    <hr />
    <p>Has published books:</p>
    <span>{{ publishedBooksMessage }}</span>
    <hr />
    <span v-for="n in 10">{{ n }}</span>
    <hr />
    <input v-model="text">
    <button @click="submit">Button</button>
    <hr />
    <p>{{ initialCounter }}</p>
    <hr />
    <p>Vuex store: {{ $store.state.count }}</p>
    <button @click="increment">Increment</button>
    <button @click="decrement">Decrement</button>
    <button @click="resetToZero">Back to zero</button>
  </section>
</template>

<style>
hr {
  margin: 10px 0;
}

@media (min-width: 1024px) {
  section.about {
    min-height: 100vh;
    display: flex;
    align-items: center;
    gap: 20px;
    align-content: center;
  }
}
</style>
